                    PROGRAM
                    MAP
Main                    PROCEDURE
                    END

    INCLUDE('trackbar.inc'),ONCE

    CODE
    Main
    RETURN

Main                PROCEDURE

Window                  WINDOW('Sliders...'),AT(,,319,192),FONT('Tahoma',8,,FONT:regular,CHARSET:ANSI),CENTER,IMM, |
                            SYSTEM,GRAY,DOUBLE
                            IMAGE('slider1c.bmp'),AT(53,37),USE(?Slider1Image)
                            REGION,AT(47,45,244,17),USE(?Slider1)
                            IMAGE('slider2c.bmp'),AT(95,108),USE(?Slider2Image)
                            REGION,AT(87,116,203,17),USE(?Slider2)
                            STRING(''),AT(3,49,40,10),USE(?BaseDelayDisplay,300),TRN,CENTER
                            STRING(''),AT(61,121,19,10),USE(?AlarmRepeatDisplay,400),TRN,CENTER
                            BUTTON('Close'),AT(219,159,45,14),USE(?CloseButton),STD(STD:Close)
                        END

BaseDelay               LONG
BaseDelaySlider         LONG(4)

AlarmRepeatDelay        DECIMAL(4,1)
AlarmRepeatSlider       LONG

Slider1                 CLASS(cTrackbar)
TakeNotification            PROCEDURE(),LONG,DERIVED
                        END
Slider2                 CLASS(cTrackbar)
TakeNotification            PROCEDURE(),LONG,DERIVED
                        END


    CODE
    OPEN(Window)

    DO SetupSliders
    DO EvaluateBaseDelay
    DO EvaluateAlarmRepeat

    ACCEPT
        IF EVENT() = EVENT:OpenWindow
            Slider1.Unhide
            Slider2.Unhide
            Slider1.Select
        END

    END

    CLOSE(Window)
    RETURN



SetupSliders        ROUTINE
  !
  ! Slider setup . . .
  !
    Slider1.m_Style = bor(WS_CHILD, bor(WS_VISIBLE, WS_TABSTOP))
    Slider1.m_Style = bor(Slider1.m_Style, TBS_TOP)
    Slider1.m_Style = bor(Slider1.m_Style, TBS_NOTICKS)
    Slider1.m_StyleEx = 0
    IF NOT Slider1.CreateTB(?Slider1, 0{PROP:ClientHandle})
        MESSAGE('|Unable to initialize user interface (1)||Program halted!|', 'Error', ICON:Hand)
        RETURN
    END
    Slider1.m_SliderPos &= BaseDelaySlider
    Slider1.SetLimit(4,139)                           ! 4-59s & 1-59m & 1-24h = 139 ticks
    Slider1.SetPos(BaseDelaySlider)

    Slider2.m_Style = bor(WS_CHILD, bor(WS_VISIBLE, WS_TABSTOP))
    Slider2.m_Style = bor(Slider2.m_Style, TBS_TOP)
    Slider2.m_Style = bor(Slider2.m_Style, TBS_NOTICKS)
    Slider2.m_StyleEx = 0
    IF NOT Slider2.CreateTB(?Slider2, 0{PROP:ClientHandle})
        MESSAGE('|Unable to initialize user interface (2)||Program halted!|', 'Error', ICON:Hand)
        RETURN
    END
    Slider2.m_SliderPos &= AlarmRepeatSlider
    Slider2.SetLimit(0,120)                           ! 0 to 60 secs in 0.5 increments = 122 ticks
    Slider2.SetPos(AlarmRepeatSlider)
    EXIT



EvaluateBaseDelay   ROUTINE
    IF INRANGE(BaseDelaySlider,0,56)
        BaseDelay      = INT(BaseDelaySlider/56 * 59)
        300{PROP:Text} = INT(BaseDelaySlider/56 * 59) & ' seconds'
    ELSIF INRANGE(BaseDelaySlider,57,115)
        BaseDelay      = INT(BaseDelaySlider-56) * 60
        300{PROP:Text} = INT(BaseDelaySlider-56) & ' minute' & CHOOSE( BaseDelay > 60, 's', '')
    ELSE
        BaseDelay      = (BaseDelaySlider-115) * 3600
        300{PROP:Text} = (BaseDelaySlider-115) & ' hour' & CHOOSE( BaseDelay > 3600, 's', '')
    END
    EXIT



EvaluateAlarmRepeat ROUTINE
    AlarmRepeatDelay = CHOOSE( NOT AlarmRepeatSlider, 0, AlarmRepeatSlider * 0.5 )
    400{PROP:Text}   = FORMAT(AlarmRepeatDelay,@N4.1)
    EXIT






Slider1.TakeNotification    PROCEDURE
ReturnValue                     LONG,AUTO
    CODE
    ReturnValue = PARENT.TakeNotification()
    DO EvaluateBaseDelay
    RETURN ReturnValue



Slider2.TakeNotification    PROCEDURE
ReturnValue                     LONG,AUTO
    CODE
    ReturnValue = PARENT.TakeNotification()
    DO EvaluateAlarmRepeat
    RETURN ReturnValue

